<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../mixins';
import SideNavigationDropdown from './side-navigation-dropdown.vue';

export default Vue.extend({
  components: { SideNavigationDropdown },
  mixins: [IsMobileMixin],
  props: {
    links: {
      required: true,
      type: Array,
    },
    button: {
      required: false,
      type: Object,
      default: null,
    },
    textLink: {
      required: false,
      type: Object,
      default: null,
    },
    footerTextLink: {
      required: false,
      type: Object,
      default: null,
    },
    footer: {
      required: false,
      type: String,
      default: null,
    },
    darkMode: {
      type: Boolean,
      required: false,
    },
    partnersVariation: {
      type: Boolean,
      required: false,
    },
    navImage: {
      type: Object,
      default: null,
      required: false,
    },
    partnerButtons: {
      type: Array,
      default: null,
      required: false,
    },
    variant: {
      required: false,
      type: String,
      default: null,
    },
  },
  data() {
    return {
      currentLinkIndex: 0,
      isDarkMode: this.darkMode,
      observer: null,
    };
  },
  beforeDestroy() {
    // Clean up observer to avoid memory leaks
    this.observer?.disconnect();
  },
  mounted() {
    const bottomObserverMargin = (window.innerHeight - 120 - 48) * -1;

    window.addEventListener('load', () => {
      if (!this.isMobile && this.$refs['side-nav-children']) {
        const sideNav = this.$refs['side-nav-children'].$el;
        const children = Array.from(sideNav.children);
        // Only add sections that are meant to be navigated to
        const sidenavSections = children.filter((section: any) => section.id);
        // Assign new observer to component's observer
        // To use this add a "data-darkmode="true" on your component's tag wrapped by the side-navigation-variant
        this.observer = new IntersectionObserver(
          (entries) => {
            entries.forEach((entry) => {
              if (entry.isIntersecting) {
                this.currentLinkIndex = sidenavSections.findIndex(
                  (item) => item === entry.target,
                );
                this.isDarkMode =
                  entry.target.dataset.darkmode ||
                  entry.target.dataset.slippersScrollDarkmode;
              }
            });
          },
          {
            rootMargin: `-120px 0px ${bottomObserverMargin}px 0px`,
          },
        );
        sidenavSections.forEach((section) => this.observer.observe(section));
      }
    });
  },
});
</script>

<template>
  <SlpContainer
    :class="variant == 'solutions-platform' ? 'platform-template' : ''"
  >
    <SlpRow v-if="isMobile" id="side-nav-parent">
      <SideNavigationDropdown :links="links" :button="button || textLink" />
      <slot ref="side-nav-children" />
    </SlpRow>
    <SlpRow v-else id="side-nav-parent">
      <SlpColumn
        id="side-navigation"
        :cols="partnersVariation ? 3 : 2"
        class="side-navigation"
      >
        <ul
          id="side-navigation__wrapper"
          class="side-navigation__wrapper"
          :class="{ partners: partnersVariation }"
        >
          <div
            v-if="partnersVariation"
            class="side-navigation__partners-variation"
          >
            <img
              :key="navImage.url"
              :src="navImage.url"
              :alt="navImage.alt"
              loading="lazy"
            />
            <div v-if="partnerButtons">
              <SlpButton
                v-for="partnerButton in partnerButtons"
                :key="partnerButton.text"
                :href="partnerButton.externalUrl"
                :variant="partnerButton.variant || partnerButton.variation"
                :data-ga-name="partnerButton.data_ga_name"
                :data-ga-location="partnerButton.data_ga_location"
                class="slp-mb-16"
              >
                {{ partnerButton.text }}
                <SlpIcon
                  v-if="partnerButton.icon.name"
                  size="sm"
                  class="slp-ml-8"
                  :icon="partnerButton.icon.name"
                  :variant="partnerButton.icon.variant"
                  :name="partnerButton.icon.name"
                />
              </SlpButton>
            </div>
            <div v-if="footer">{{ footer }}</div>
            <SlpButton
              v-if="footerTextLink"
              class="side-navigation__text-link"
              :href="footerTextLink.url"
              variant="tertiary"
              :data-ga-name="footerTextLink.data_ga_name"
              :data-ga-location="footerTextLink.data_ga_location"
            >
              {{ footerTextLink.text }}
              <SlpIcon
                name="chevron-lg-right"
                variant="product"
                alt="Chevron Right Icon"
              />
            </SlpButton>
          </div>
          <li
            v-for="(link, index) in links"
            :key="link.title"
            class="slp-py-8 slp-my-8"
          >
            <SlpTypography
              class="side-navigation__text slp-pb-4"
              :class="{
                'side-navigation__text--hover': index === currentLinkIndex,
                'side-navigation__text--dark': isDarkMode,
                'side-navigation__text--dark-hover':
                  index === currentLinkIndex && isDarkMode,
              }"
              variant="body2"
              tag="a"
              :href="link.href"
              :data-ga-name="link.href.slice('').replace('#', '')"
              data-ga-location="side anchor"
            >
              {{ link.title }}
            </SlpTypography>
          </li>
          <SlpButton
            v-if="button"
            :href="button.url"
            :variant="isDarkMode ? 'secondary' : 'primary'"
            :data-ga-name="button.data_ga_name"
            :data-ga-location="button.data_ga_location"
          >
            {{ button.text }}
          </SlpButton>
          <SlpButton
            v-if="textLink"
            class="side-navigation__text-link"
            :href="textLink.url"
            variant="tertiary"
            :data-ga-name="textLink.data_ga_name"
            :data-ga-location="textLink.data_ga_location"
          >
            {{ textLink.text }}
            <SlpIcon
              name="chevron-lg-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
        </ul>
      </SlpColumn>

      <SlpColumn ref="side-nav-children">
        <slot></slot>
      </SlpColumn>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.platform-template {
  :deep {
    .side-navigation__text {
      color: $color-text-link-100;
      font-size: 14px;
      font-style: normal;
      font-weight: 600;
      line-height: 22px;
      opacity: 1;
      &:hover,
      &:focus {
        color: $color-text-link-100;
        box-shadow: none;
        -webkit-text-decoration: underline;
        text-decoration: underline;
        text-decoration-thickness: 2px;
        text-underline-offset: 3px;
      }
    }
    .side-navigation__wrapper {
      max-height: calc(100vh - 96px);
      overflow-y: scroll;
      -ms-overflow-style: none;
      scrollbar-width: none;
      &::-webkit-scrollbar {
        display: none;
      }
    }
    .side-navigation__wrapper li {
      margin: 0;
      padding-bottom: 8px;
      padding-top: 0;
    }
    .side-navigation__text--hover {
      box-shadow: none;
      -webkit-text-decoration: underline;
      text-decoration: underline;
      text-decoration-thickness: 2px;
      text-underline-offset: 3px;
    }
  }
}
.side-navigation {
  &__wrapper {
    position: sticky;
    margin-top: $spacing-96;
    padding-bottom: $spacing-96;
    width: 100%;
    padding-left: $spacing-8;
    overflow: hidden;
    display: none;
    top: 170px;

    @media (min-width: $breakpoint-lg) {
      display: block;
    }
    &.partners {
      padding-right: $spacing-16;
    }
  }

  &__text-link {
    color: $color-text-link-100;
    text-decoration: none;
    font-size: 16px;
    font-weight: 600;
  }

  &__partners-variation {
    img {
      max-width: 150px;
      margin-bottom: $spacing-32;
    }
    margin-bottom: $spacing-32;
    .slp-btn-secondary {
      border-radius: 4px;
      border: 1px solid $color-surface-700;
      transition: 0.25s;

      &:hover {
        border: 1px solid $color-surface-200;
      }
    }
  }

  &__text {
    transition: all 0.25s ease;
    opacity: 0.2;
    font-weight: 700;
    line-height: 12px;
    text-decoration: none;
    color: hsl(257, 27%, 10%);

    &--hover {
      box-shadow: inset 0 -2px 0 0 $color-accent-500;
      opacity: 1;
    }

    &--dark {
      color: $color-surface-400;
      opacity: 1;

      &-hover {
        color: $color-text-50;
      }

      &:hover {
        text-decoration: none;
        color: $color-surface-300 !important;
      }
    }

    &:hover {
      text-decoration: none;
      color: $color-text-300;
      opacity: 1;
    }
  }
}
</style>
